#include <stdio.h>

using namespace std;

int main(){
    int n, k;
    scanf("%d %d", &n, &k);
    int a[n];
    int primeK = k;
    for (int i = 0; i < n; i++){
        scanf("%d", &a[i]);
    }
    bool b[n] = {false};
    int i = 0;
    int ss = 0;
    while (i < n-1 && k > 0){
        if (a[i] > a[i+1]){
            for(int j = 0; j < i; j++){
                if (j > i) break;
                if (a[j] > a[i] && i - j <= primeK && !b[j]){
                    b[j] = true;
                    k--;
                }
            }
            if (k > 0){
            b[i] = true;
            k--;
            }
            printf("%d\n", a[i]);

            ss = i;
        }
        else
            b[i] = false;
        i++;
    }
    for (i = 0; i < n; i++){
        if (!b[i]) printf("%d ", a[i]);
    }
    return 0;
}